"""Add user table

Revision ID: 178719586e69
Revises: b746cd9b6b41
Create Date: 2023-09-02 09:25:14.639066

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "178719586e69"
down_revision = "b746cd9b6b41"
branch_labels = None
depends_on = None


def upgrade() -> None:
    op.execute(sa.schema.CreateSequence(sa.Sequence("user_id_seq")))
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "user",
        sa.Column(
            "id",
            sa.Integer(),
            server_default=sa.text("nextval('user_id_seq')"),
            nullable=False,
            comment="Serial user ID.",
        ),
        sa.Column(
            "username",
            sa.String(length=20),
            nullable=False,
            comment="Username.",
            unique=True,
        ),
        sa.Column(
            "password",
            sa.Text,
            nullable=False,
            comment="Hashed password.",
        ),
        sa.PrimaryKeyConstraint("id"),
        comment="Users.",
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("user")
    # ### end Alembic commands ###
    op.execute(sa.schema.DropSequence(sa.Sequence("user_id_seq")))
